#include "aiplayer.h"
#include "game.h"

namespace AntiKill
{

AIPlayer::AIPlayer(string name, string role)
	: Player(name, role)
{
	waitTime = 50;
}

AIPlayer::~AIPlayer()
{
}

}

void AntiKill::AIPlayer::move()
{
	Game &g  = Game::getInstance();
	Player* main = g.getMainPlayer();
	if(!this->underControl){
		Object* board = this->getBoard();
		if( --waitTime<=0 && main && main->isAlive() ){
			int i = rand()%7;
			switch(i){
			case 0:
			//	jump(true);
			//	break;
			case 1:
			case 2:
			case 3:
				if( g.getMapSystem().inClient(this->getCentralX(), this->getCentralY() )){
					int cx, cy;
					if(g.getBlockSystem().checkLineCollision(this->getColor(), getX(), getY(), main->getCentralX(),
						main->getCentralY(), &cx, &cy) ){
						if( g.getBlockSystem().getObjectByPosition(cx, cy)==main )
							fire(main->getCentralX()+(rand()%120)-60, main->getCentralY()+(rand()%120)-60);
					}
				}
				break;
				break;
			case 4:
				if(board){
					PlayerAction pa;
					pa.type = ActionMove;
					pa.x = g.getMapSystem().getWidth();
					pa.x = rand()%2 ? pa.x : -pa.x;
					this->setAction(pa);
				}
				break;
			}
			waitTime = 20;
		}
		//don't let the player go off the board
		if( board ){
			if(this->playerActionOn && ( this->getX()-board->getX()<=this->getWidth() || 
				this->getX()+this->getWidth()*2-board->getX()>board->getWidth() ) ){
				this->stopAction();
				this->stop();
				acting = false;
			}
		}
	}
	Player::move();
	jump(false);
	holdFire();
}

void AntiKill::AIPlayer::doMoveLeft()
{
	this->aim(this->getCentralX() - this->getWidth(), this->getCentralY() );
	Player::doMoveLeft();
}

void AntiKill::AIPlayer::doMoveRight()
{
	this->aim(this->getCentralX() + this->getWidth(), this->getCentralY() );
	Player::doMoveRight();
}

void AntiKill::AIPlayer::doFire()
{
	this->aim(fireX, fireY);
	Player::doFire();
}

bool AntiKill::AIPlayer::isUnderControl() const
{
	return this->underControl;
}

void AntiKill::AIPlayer::setControlMode(bool mode)
{
	this->underControl = mode;
}

