#ifndef ANIMATION_H
#define ANIMATION_H

#include <allegro.h>
#include <vector>
using namespace std;

#define MAX_IMAGE_PER_ACTION 20
#define DIR_LEFT 1
#define DIR_RIGHT 0
#define DIR_TOP 2
#define DIR_BOTTOM 3

namespace AntiKill
{

struct AniAction{
	int index;
	int frameCount;
	int frameRate;
	bool loop;
	BITMAP* pic;
	BITMAP*	sub[MAX_IMAGE_PER_ACTION];
};
class Animation {
	vector<AniAction*> actions;
	int action;
	int frame;
	int direction;
	int actionCount;
	int frameRate;
	int timer;
	AniAction* current;
	bool loop;
public:
	Animation();
	virtual ~Animation();
	void load(const char* file);
	int getFrameWidth() ;
	int getFrameHeight() ;
	void setFrame(int i);
	void setAction(int i);
	void setAction(int i, bool l);
	void setDirection(int d);
	int getFrame();
	int getDirection();
	int getAction();
	void nextFrame();
	virtual void draw(BITMAP* dest, int x, int y);
};

}

#endif // ANIMATION_H
