#ifndef BLOCKSYSTEM_H
#define BLOCKSYSTEM_H

#include "object.h"
#include <vector>
using namespace std;

namespace AntiKill
{

class BlockSystem {
private:
	int blockWidth;
	int blockHeight;
	int rows;
	int cols;
	bool iterating;
	vector<Object*>** blocks;
	BITMAP* blockMap;
	int blockColor;
public:
	BlockSystem();
	~BlockSystem();
	void initialize(int mapw, int maph);
	void addObject(Object* o);
	void addObject(Object* o, int x1, int y1, int x2, int y2);
	void removeObject(Object* o);
	void removeObject(Object* o, int x1, int y1, int x2, int y2);
	bool checkCollision(Object* o);
	bool checkCollision(Object* o, int x1, int y1, int x2, int y2);
	bool checkLineCollision(int col, int x1, int y1, int x2, int y2, int* cx, int *cy);
	Object* getObjectByPosition(int x, int y);
	void cleanup();
	void draw(BITMAP* dest, int x, int y);
	BITMAP* getBlockMap();
};

}

#endif // BLOCKSYSTEM_H
