#include "bullet.h"
#include "game.h"
#include "firestar.h"
#include <iostream>
using namespace std;

namespace AntiKill
{


Bullet::Bullet(Player* p, int srcX, int srcY, int destX, int destY)
{
	Game& g = Game::getInstance();
	float k, dy, dx;
	Vector v;
	setX(srcX);
	setY(srcY);
	this->owner = p;
	//check collision
	if( g.getBlockSystem().checkLineCollision( p->getColor(), srcX, srcY, destX, destY, &blockX, &blockY )){
		destX = blockX;
		destY = blockY;
	}
	
	this->destX = destX;
	this->destY = destY;
	this->srcX = srcX;
	this->srcY = srcY;
	dy = destY - srcY;
	dx = destX - srcX;
	show();
	speed = 100.0;
	//set up velocity
	if( destY==srcY ){
		v.x = destX > srcX ? speed:-speed;
		v.y = 0.0;
	}else if(destX==srcX){
		v.x = 0.0;
		v.y = destY > srcY ? speed:-speed;
	}else{
		k = dy / dx;
		v.x = sqrtf(speed*speed/(k*k+1));
		if(dx<0)
			v.x = -v.x;
		v.y = k*v.x;
	}
	
	distance = (dx*dx+dy*dy);
	setVelocity(v);
}

Bullet::~Bullet()
{
}

}

void AntiKill::Bullet::draw(BITMAP* dest, int x, int y)
{
	int ox = position.x-velocity.x-x;
	int oy = position.y-velocity.y-y;
	int ex = getX()-x;
	int ey = getY()-y;
	line(dest, ox, oy, ex, ey, makecol(255,255,255));
}

void AntiKill::Bullet::move()
{
	float dist, dx, dy;
	this->position += this->velocity;
	if( this->velocity.x < 0.0 ){
		if(destX>position.x){
			die();
			this->velocity.x = destX - (this->position.x - this->velocity.x );
		}
	}else{
		if(destX<position.x){
			die();
			this->velocity.x = destX - (this->position.x - this->velocity.x );
		}
	}
	if( this->velocity.y < 0.0 ){
		if(destY>position.y){
			die();
			this->velocity.y = destY - (this->position.y - this->velocity.y );
		}
	}else{
		if(destY<position.y){
			die();
			this->velocity.y = destY - (this->position.y - this->velocity.y );
		}
	}
	if(this->isDead()){
		Game& g = Game::getInstance();
		position.x = destX;
		position.y = destY;
		FireStar *f = new FireStar(destX, destY);
		g.getObjectSystem().addObject(f);
		Object* o = g.getBlockSystem().getObjectByPosition(destX, destY);
		if(o){
			Player* p = dynamic_cast<Player*>(o);
			if(p && p!=this->owner){
				Vector v = this->velocity;
				v.normalize();
				bool alive = p->isAlive();
				bool head = p->hit(destX, destY, v);
				if(alive && !p->isAlive()){
					owner->addKills();
					if(head)
						owner->addHeadshots();
				}
			}
		}
	}
}
