#ifndef DIALOG_H
#define DIALOG_H

#include <allegro.h>
#include <string>
#include <vector>
using namespace std;


namespace AntiKill
{

class Dialog {
private:
	string	message;
	bool	visible;
	int	delay;
	int	counter;
	int	x, y;
	int	w, h;
	int	textColor, bgColor;
	BITMAP* bitmap;
	vector<string> lines;
	int	cellSpace;
	int	margin;
	void	build();
public:
	Dialog();
	~Dialog();
	Dialog& setPosition(int x, int y);
	Dialog& show();
	Dialog& hide();
	void move();
	void draw(BITMAP* desc, int cx, int cy);
	Dialog& setDelay(int t);
	Dialog& setText(string text);
	Dialog& setColor(int c);
	const string& getText() const;
	bool isVisible() const;
};

}

#endif // DIALOG_H
