#include "eventsystem.h"
#include "bullet.h"
#include "game.h"
#include <iostream>

namespace AntiKill
{

EventSystem::EventSystem()
{
}

EventSystem::~EventSystem()
{
}

}

void AntiKill::EventSystem::addEvent(Event* e)
{
	events.push(e);
}

void AntiKill::EventSystem::clear()
{
	while(events.size()>0)
		events.pop();
}

void AntiKill::EventSystem::handleEvents()
{
	Game& g = AntiKill::Game::getInstance();
	while(events.size()>0){
		Event* e = events.back();
		Player* p = g.getPlayer(e->player);
		events.pop();
		if(g.getDialog().isVisible()){
			if(e->action==FireAction)
				g.getDialog().hide();
		}else if(g.canControl()){
			if(!p)return;
			switch(e->action){
			case AimAction:
			{
				g.getAimSystem().setX(e->value>>16);
				g.getAimSystem().setY(e->value&0xffff);
				int ax = g.getAimSystem().getX()+g.getMapSystem().getClientX(), 
					ay = g.getAimSystem().getY()+g.getMapSystem().getClientY();
				p->aim(ax, ay);
				if(p->isFiring())
					p->fire( ax, ay );
				break;
			}
			case FireAction:
				if(e->press){
					p->fire(g.getAimSystem().getX()+g.getMapSystem().getClientX(), 
						g.getAimSystem().getY()+g.getMapSystem().getClientY());
				}else{
					p->holdFire();
				}
				break;
			case AidAction:
				break;
			case JumpAction:
				if(e->press){
					p->jump(true);
				}else{
					p->jump(false);
				}
				break;
			case GoLeftAction:{
				if(e->press){
					p->moveLeft(true);
				}else{
					p->moveLeft(false);
				}
				break;
			}
			case GoRightAction:
				if(e->press){
					p->moveRight(true);
				}else{
					p->moveRight(false);
				}
				break;
			case ReloadAction:{
				Weapon* w = p->getCurrentWeapon();
				if(w)
					w->reload();
				break;
			}
			case SquatAction:
				break;
			case RunAction:
				break;
			case UseGunAction:
				p->setEquipment(EquipGun);
				break;
			case UsePistolAction:
				p->setEquipment(EquipPistol);
				break;
			case UseKnifeAction:
				p->setEquipment(EquipNone);
				break;
			case UseGrenadeAction:
				p->setEquipment(EquipGrenade);
				break;
			case QuickSwitchAction:
				break;
			default:
				std::cout << "Unknown action " << e->action << endl;
			}
			delete e;
		}
	}
}

