#ifndef EVENTSYSTEM_H
#define EVENTSYSTEM_H

#include <queue>
using namespace std;

#define MAX_EVENT 30
enum EventAction{
	FireAction = 0,
	AidAction,
	JumpAction,
	GoLeftAction,
	GoRightAction,
	ReloadAction,
	SquatAction,
	RunAction,
	UseGunAction,
	UsePistolAction,
	UseKnifeAction,
	UseGrenadeAction,
	QuickSwitchAction,
	BuyAction,
	TeamSwitchAction,
	AimAction
};

struct Event{
	int player;
	enum EventAction action;
	bool press;
	int value;
};

namespace AntiKill
{

class EventSystem {
	queue<Event*> events;
public:
	EventSystem();
	~EventSystem();
	void addEvent(Event* e);
	void handleEvents();
	void clear();
};

}

#endif // EVENTSYSTEM_H
