#include "explosion.h"
#include "game.h"

namespace AntiKill
{


Explosion::~Explosion()
{
}

}

AntiKill::Explosion::Explosion(Player* p, int x, int y)
{
	this->owner = p;
	lifetime = 10;
	radius = 1;
	setX(x);
	setY(y);
	show();
}


void AntiKill::Explosion::draw(BITMAP* dest, int x, int y)
{
	circlefill(dest, getX()-x, getY()-y, radius, makecol(255,255,255) );
}

void AntiKill::Explosion::move()
{
	Game& g = Game::getInstance();
	vector<Player*>* v = (vector<Player*>*)g.getPlayers();
	for(vector<Player*>::iterator it=v->begin(); it!=v->end(); it++){
		Player* p = *it;
		int x = p->getCentralX(), y = p->getCentralY();
		int dx = x - getX(), dy = y - getY();
		if( (dx*dx+dy*dy) <= radius*radius ){
			Vector dir(dx, dy);
			dir.normalize();
			bool alive = p->isAlive();
			bool head = p->hit(x, y, dir);
			if(alive && !p->isAlive()){
				owner->addKills();
				if(head)
					owner->addHeadshots();
			}
		}
	}
	radius += 20;
	lifetime --;
	if(lifetime <= 0)
		die();
}

