#include "frontsight.h"
#include <iostream>
using namespace std;

namespace AntiKill
{

FrontSight::FrontSight()
{
	trembling = 0;
	defaultDivergence = 5;
	divergence = defaultDivergence;
	maxDivergence = 50;
}

FrontSight::~FrontSight()
{
}

}

int AntiKill::FrontSight::getDivergence() const
{
	return this->divergence;
}

int AntiKill::FrontSight::getTrembling()
{
	return this->trembling;
}

void AntiKill::FrontSight::setDivergence(int div)
{
	this->divergence = div;
}

void AntiKill::FrontSight::setTrembling(int t)
{
	this->trembling = t;
}

void AntiKill::FrontSight::draw(BITMAP* dest)
{
	int x = getX();
	int y = getY();
	int starWidth = 6;
	//left
	line(dest, x-divergence-starWidth, y, x-divergence, y, makecol(0,255,0));
	//right
	line(dest, x+divergence, y, x+divergence+starWidth, y, makecol(0,255,0));
	//top
	line(dest, x, y-divergence-starWidth, x, y-divergence, makecol(0,255,0));
	line(dest, x, y+divergence, x, y+divergence+starWidth, makecol(0,255,0));
}

void AntiKill::FrontSight::move()
{
	Vector v = getVelocity();
	Vector a = getAcceleration();
	if( (fabs(v.x) > 0.1 || fabs(v.y)>0.1) ){
		a.x = -v.x*(rand()%100)/100;
		a.y = -v.y*(rand()%100)/100;
		setAcceleration(a);
	}
	if( divergence > defaultDivergence )
		divergence -= 2;
	Object::move();
}

void AntiKill::FrontSight::jump(int dist)
{
	//Calculate the distance from the front sight to the player
	//
	Vector v((rand()%(dist*2+1))-dist, (rand()%(dist*2+1))-dist);
	addMomentum(v);
	if( divergence < maxDivergence)
		divergence += dist;
}

