#include "grenade.h"
#include "grenadethrown.h"
#include "game.h"

namespace AntiKill
{

Grenade::Grenade(Player* p):
	Weapon(p, "grenade")
{
	reloadTime = 50;
	bulletsPerClip = 1;
	this->fireInterval = 1;
}

Grenade::~Grenade()
{
}

}

bool AntiKill::Grenade::fire(int fireX, int fireY)
{
	if(Weapon::fire(fireX, fireY)){
		Game& g = Game::getInstance();
		int srcX = this->owner->getCentralX(), srcY = this->owner->getCentralY();
		Vector v;
		v.x = fireX - srcX, v.y = fireY - srcY;
		v.normalize();
		v *= this->getWidth()/2;
		srcX += v.x;
		srcY += v.y;
		GrenadeThrown* b = new GrenadeThrown(this->owner, srcX, srcY, fireX, fireY, 0);
		g.getObjectSystem().addObject(b);
	}
}

