#ifndef GRENADETHROWN_H
#define GRENADETHROWN_H

#include "player.h"
#include "realbody.h" // Base class: AntiKill::RealBody

namespace AntiKill
{

class GrenadeThrown : public AntiKill::RealBody {
private:
	Player* owner;
	int	destX, destY;
	int	srcX, srcY;
	int	speed;
	int 	lifetime;
	int 	born;
	int	hitSoundDelay;
public:
	GrenadeThrown(Player* o, int srcX, int srcY, int fireX, int fireY, int strength);
	virtual ~GrenadeThrown();
	virtual void draw(BITMAP* dest, int cx, int cy);
	virtual void move();
	virtual void handleCollision(int dir, Object* o);
	virtual bool collide(Object*);
	virtual void bomb();
};

}

#endif // GRENADETHROWN_H
