#include "gun.h"
#include "bullet.h"
#include "game.h"

namespace AntiKill
{

Gun::Gun(Player* p):
	Weapon(p, "gun")
{
	reloadTime = 100;
	bulletsPerClip = 30;
	this->fireInterval = 7;
}

Gun::~Gun()
{
}

bool Gun::fire(int fireX, int fireY)
{
	if(Weapon::fire(fireX, fireY)){
		Game& g = Game::getInstance();
		if(g.getMainPlayer()->getCurrentWeapon()==this)
			g.getAimSystem().jump(30);
		int srcX = this->owner->getCentralX(), srcY = this->owner->getCentralY();
		Vector v;
		v.x = fireX - srcX, v.y = fireY - srcY;
		v.normalize();
		v *= this->getWidth()/2;
		srcX += v.x;
		srcY += v.y;
		Bullet* b = new Bullet(this->owner, srcX, srcY, fireX, fireY);
		g.getObjectSystem().addObject(b);
		g.getSoundSystem().playSound("gun");
	}
}

void Gun::reload()
{
	if(!this->reloading){
		Game& g = Game::getInstance();
		g.getSoundSystem().playSound("gun_reload");
		Weapon::reload();
	}
}

}

