#include <allegro.h>
#include "inputsystem.h"
#include "game.h"
#include <iostream>

namespace AntiKill
{

InputSystem::InputSystem()
{
}

InputSystem::~InputSystem()
{
}

}

bool AntiKill::InputSystem::initialize()
{
	install_keyboard();
	install_mouse();
	memset(eventKey, 0, sizeof(eventKey));
}

void AntiKill::InputSystem::doInput()
{
	Game& g = Game::getInstance();
	ClientNetwork& client = g.getClientNetwork();
	if( mouse_x!=oldMouseX || mouse_y!=oldMouseY ){
		Event* e = new Event();
		e->action = AimAction;
		e->value = (mouse_x<<16)|mouse_y;
		client.sendEvent(e);
		oldMouseX = mouse_x;
		oldMouseY = mouse_y;
	}
	if(mouse_b&1)
		pressKey(FireAction);
	else 
		freeKey(FireAction);
	if(mouse_b&2)
		pressKey(AidAction);
	else 
		freeKey(AidAction);
	if(key[KEY_A])
		pressKey(GoLeftAction);
	else
		freeKey(GoLeftAction);
	if(key[KEY_A])
		pressKey(GoLeftAction);
	else
		freeKey(GoLeftAction);
	if(key[KEY_D])
		pressKey(GoRightAction);
	else
		freeKey(GoRightAction);
	if(key[KEY_W])
		pressKey(JumpAction);
	else
		freeKey(JumpAction);
	if(key[KEY_S])
		pressKey(SquatAction);
	else
		freeKey(SquatAction);
	if(key[KEY_R])
		pressKey(ReloadAction);
	else
		freeKey(ReloadAction);
	if(key[KEY_LSHIFT])
		pressKey(RunAction);
	else
		freeKey(RunAction);
	if(key[KEY_1])
		pressKey(UseGunAction);
	else
		freeKey(UseGunAction);
	if(key[KEY_2])
		pressKey(UsePistolAction);
	else
		freeKey(UsePistolAction);
	if(key[KEY_3])
		pressKey(UseKnifeAction);
	else
		freeKey(UseKnifeAction);
	if(key[KEY_4])
		pressKey(UseGrenadeAction);
	else
		freeKey(UseGrenadeAction);
	if(key[KEY_Q])
		pressKey(QuickSwitchAction);
	else
		freeKey(QuickSwitchAction);
	if(key[KEY_B])
		pressKey(BuyAction);
	else
		freeKey(BuyAction);
	if(key[KEY_M])
		pressKey(TeamSwitchAction);
	else
		freeKey(TeamSwitchAction);
}

void AntiKill::InputSystem::pressKey(enum EventAction action)
{
	if(!eventKey[action]){
		Game& g = Game::getInstance();
		ClientNetwork& client = g.getClientNetwork();
		Event* e = new Event();
		e->action = action;
		e->press = true;
		client.sendEvent(e);
		eventKey[action] = true;
	}
}

void AntiKill::InputSystem::freeKey(enum EventAction  action)
{
	if(eventKey[action]){
		Game& g = Game::getInstance();
		ClientNetwork& client = g.getClientNetwork();
		Event* e = new Event();
		e->action = action;
		e->press = false;
		client.sendEvent(e);
		eventKey[action] = false;
	}
}

