#include "lock.h"
#include <pthread.h>

namespace AntiKill{
	static pthread_mutex_t	gameLock;
	
	void initializeLock(){
		pthread_mutex_init(&gameLock, 0);
	}
	
	void destroyLock(){
		pthread_mutex_destroy(&gameLock);
	}
	
	void lockGame(){
		pthread_mutex_lock(&gameLock);
	}
	
	void unlockGame(){
		pthread_mutex_unlock(&gameLock);
	}
	
	void* createThread( void* obj, void*(*func)(void*) ){
		int ret;
		pthread_t * p = new pthread_t;
		ret = pthread_create(p, 0, func, obj);
		return p;
	}
	
	void joinThread( void* obj ){
		pthread_join(*((pthread_t*)obj), 0);
		delete (pthread_t*)obj;
	}
};
