#ifndef MAPSYSTEM_H
#define MAPSYSTEM_H

#include <allegro.h>
#include "object.h"

namespace AntiKill
{

class MapSystem {
private:
	BITMAP* bitmap;
	int clientX;
	int clientY;
	int clientWidth;
	int clientHeight;
	int mapWidth;
	int mapHeight;
	int mapType;
	int scrollWidth;
	int scrollHeight;
	Object* followObject;
	int objectX, objectY;
	int backgroundColor;
public:
	MapSystem();
	~MapSystem();
	void draw(BITMAP* dest);
	int getClientX()const;
	int getClientY()const;
	int getClientWidth()const;
	int getClientHeight()const;
	bool inClient(int x, int y);
	MapSystem& setClientX(int x);
	MapSystem& setClientY(int y);
	MapSystem& setClientWidth(int w);
	MapSystem& setClientHeight(int h);
	int getWidth()const;
	int getHeight()const;
	void setFollowObject(Object* o);
	void moveClient();
	void moveClientTo(int x, int y);
	Object* getFollowObject();
	void initialize(int w, int h);
	void setBackgroundColor(int r, int g, int b);

};

}

#endif // MAPSYSTEM_H
