#ifndef OBJECTSYSTEM_H
#define OBJECTSYSTEM_H

#include <vector>
#include <queue>
#include "object.h"
using namespace std;


namespace AntiKill
{
	
class ObjectSystem {
	vector<Object*> objects;
	bool	iterating;
	queue<Object*> temp;
public:
	ObjectSystem();
	~ObjectSystem();
	void addObject(Object* o);
	bool removeObject(Object* o);
	void moveObjects();
	void cleanupObjects();
	void drawObjects(BITMAP* dest, int x, int y);
	void removeDeadObjects();
	int getObjectCount()const;
	Object* getObjectById(int id);
};

}

#endif // OBJECTSYSTEM_H
