#include "pistol.h"
#include "bullet.h"
#include "game.h"

namespace AntiKill
{

Pistol::Pistol(Player* p):
	Weapon(p, "pistol")
{
	reloadTime = 60;
	bulletsPerClip = 20;
	this->fireInterval = 15;
}

Pistol::~Pistol()
{
}

bool Pistol::fire(int fireX, int fireY)
{
	if(Weapon::fire(fireX, fireY)){
		Game& g = Game::getInstance();
		if(g.getMainPlayer()->getCurrentWeapon()==this)
			g.getAimSystem().jump(20);
		int srcX = this->owner->getCentralX(), srcY = this->owner->getCentralY();
		Vector v;
		v.x = fireX - srcX, v.y = fireY - srcY;
		v.normalize();
		v *= this->getWidth()/2;
		srcX += v.x;
		srcY += v.y;
		Bullet* b = new Bullet(this->owner, srcX, srcY, fireX, fireY);
		g.getObjectSystem().addObject(b);
		g.getSoundSystem().playSound("pistol");
	}
}

void Pistol::reload()
{
	if(!this->reloading){
		Game& g = Game::getInstance();
		g.getSoundSystem().playSound("pistol_reload");
		Weapon::reload();
	}
}

}

