#ifndef REALBODY_H
#define REALBODY_H

#include "object.h" // Base class: AntiKill::Object
#include <vector>
using namespace std;

namespace AntiKill
{

class RealBody : public AntiKill::Object
{
protected:
	int 	mass;
	bool 	free;
	Object*	on;
	vector<RealBody*> load;
	float	frictionAccel;
	bool	stickToGround;
public:
	RealBody();
	virtual ~RealBody();

	virtual bool collide(Object*);
	virtual void handleCollision(int dir, Object* o);
	void die();
	void draw(BITMAP* dest, int x, int y);
	void move();
	void stop();
	Object* getBoard();
	void setBoard(Object* o);
	RealBody& setMass(int m);
	int getMass() const;
	RealBody& setFree(bool f);
	bool isFree()const;
	void releaseRoad();
	void addForce(Vector& v);
	void addMomentum(Vector& m);

};

}

#endif // REALBODY_H
