#ifndef _SCREEN_H
#define _SCREEN_H

#include <allegro.h>

namespace AntiKill
{
	
enum FadeInOut{
	Invisible = 0,
	FadeIn,
	FadeOut,
	Visible
};

class Screen {
private:
	int 	width;
	int 	height;
	int 	bpp;
	int 	index;
	BITMAP* vbuffer[2];
	BITMAP* mbuffer;
	BITMAP* current;
	FadeInOut fadeInOut;
	int	alpha;
	int	rate;
public:
	Screen();
	~Screen();
	void	fadeIn();
	void	fadeOut();
	bool 	setVideoMode(int w, int h, int bpp);
	int 	getWidth()const;
	int 	getHeight()const;
	int 	getBitsPerPixel()const;
	void 	flip();
	BITMAP* getCurrentPage();
	BITMAP* getBufferPage();
	FadeInOut	getFadeMode() const;
};

}

#endif // _SCREEN_H
