#ifndef SCRIPTSYSTEM_H
#define SCRIPTSYSTEM_H

#include "shrimpscript.h"
#include <queue>
using namespace std;

namespace AntiKill
{
	
struct ScriptEvent{
	string	event;
	string	name;
	int	id;
	int	x;
	int	y;
};

class ScriptSystem {
private:
	void* scriptThread;
	ShrimpScript	script;
	queue<ScriptEvent*> scriptEvents;
public:
	void	runScript();
	ScriptSystem();
	~ScriptSystem();
	bool	start();
	void	stop();
	bool	raise(string event, string name, int x, int y);
	bool	raise(string event, int id, int x, int y);
};

}

#endif // SCRIPTSYSTEM_H
