#ifndef SOUND_H
#define SOUND_H

#include <allegro.h>
#include <string>
using namespace std;

namespace AntiKill
{

class Sound {
private:
	string name;
	SAMPLE* sample;
	MIDI*	midi;
	int pan;
	int pitch;
	int volume;
public:
	Sound();
	~Sound();
	Sound& setName(string s);
	const string& getName() const;
	void play();
	void play(int vol);
	void stop();
	bool load(string file);
	Sound& setPan(int pan);
	Sound& setPitch(int pitch);
	Sound& setVolume(int vol);
	int getPan()const;
	int getPitch()const;
	int getVolume()const;
};

}

#endif // SOUND_H
