#include "soundsystem.h"
#include <iostream>
using namespace std;

namespace AntiKill
{

SoundSystem::SoundSystem()
{
}

SoundSystem::~SoundSystem()
{
}

}

AntiKill::Sound* AntiKill::SoundSystem::addSound(string name, string file)
{
	Sound* s = new Sound();
	if(s){
		s->setName(name);
		s->load(file);
		s->setPan(pan);
		s->setPitch(pitch);
		s->setVolume(volume);
	}
	sounds.push_back(s);
	return s;
}

void AntiKill::SoundSystem::cleanup()
{
	for(vector<Sound*>::iterator it=sounds.begin();it!=sounds.end();it++ ){
		Sound* s = *it;
		delete s;
	}
	sounds.clear();
}

AntiKill::Sound* AntiKill::SoundSystem::getSound(string name)
{
	for(vector<Sound*>::iterator it=sounds.begin();it!=sounds.end();it++ ){
		Sound* s = *it;
		if(s->getName()==name)
			return s;
	}
	return 0;
}

bool AntiKill::SoundSystem::initialize()
{
	if(install_sound( DIGI_AUTODETECT, MIDI_AUTODETECT, "")!=0)
		return false;
	pan = 128;
	pitch = 1000;
	volume = 255;
	set_volume(64, 64);
	addSound("gun", "sound/weapons/m4a1_unsil-1.wav");
	addSound("pistol", "sound/weapons/p228-1.wav");
	addSound("grenade_hitground", "sound/weapons/he_bounce-1.wav");
	addSound("grenade_explode", "sound/weapons/explode3.wav");
	addSound("pistol_reload", "sound/weapons/generic_reload.wav");
	addSound("gun_reload", "sound/weapons/generic_reload.wav");
	return true;
}

void AntiKill::SoundSystem::playSound(string name)
{
	Sound* s = getSound(name);
	if(s)
		s->play(this->volume);
	else
		std::cout<<"sound not found: %s" << name << endl;
}

void AntiKill::SoundSystem::removeSound(string name)
{
	for(vector<Sound*>::iterator it=sounds.begin();it!=sounds.end();it++ ){
		Sound* s = *it;
		if(s->getName()==name){
			sounds.erase(it);
			delete s;
			return;
		}
	}
}

void AntiKill::SoundSystem::stopAll()
{
	for(vector<Sound*>::iterator it=sounds.begin();it!=sounds.end();it++ ){
		Sound* s = *it;
		s->stop();
	}
}

