#ifndef SOUNDSYSTEM_H
#define SOUNDSYSTEM_H

#include <vector>
#include <string>
#include "sound.h"
using namespace std;

namespace AntiKill
{

class SoundSystem {
private:
	int pan;	//声道平衡
	int pitch;	//频率
	int volume;
	vector<Sound*> sounds;
public:
	SoundSystem();
	~SoundSystem();
	bool initialize();
	Sound* addSound(string name, string file);
	void playSound(string name);
	void removeSound(string name);
	void cleanup();
	Sound* getSound(string name);
	void stopAll();
};

}

#endif // SOUNDSYSTEM_H
