#ifndef WEAPON_H
#define WEAPON_H

#include "object.h" // Base class: AntiKill::Object
#include <string>
using namespace std;

namespace AntiKill
{

class Player;
class Weapon : public AntiKill::Object {
protected:
	int	angle;
	int	dx, dy;
	int	bulletCurrent;
	int	bulletBackup;
	int	reloadTime;
	int	interval;
	int	fireInterval;
	int	bulletsPerClip;
	bool	reloading;
	Player*	owner;
public:
	Weapon(Player* p, string name);
	virtual ~Weapon();
	virtual void draw(BITMAP* dest, int x, int y);
	void	setTarget(int x, int y);
	int	getAngle()const;
	int	getBulletCurrent()const;
	int	getBulletTotal()const;
	Player* getOwner();
	void	setOwner(Player* p);
	void	addBullets(int v);
	void	reduceBullet();
	virtual void reload();
	int	getReloadTime()const;
	virtual bool fire(int x, int y);
	virtual void move();
};

}

#endif // WEAPON_H
